=begin

(c) RENDERIZA 2013

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE.

== Information
Author:: 
	*Renderiza 

Name:: GOSU
Version:: 1.0.5
SU Version:: v8
Date:: 4/26/2013
Description:: GOSU is a set of tools that lets you trigger different actions when you click a component.
Usage:: Use Set:: Options and then GO:: URL to left click that component & peform action.
History::
1.0.0 Beta:: 4/18/2013
	* Original release.  
1.0.1 Beta:: 4/19/2013
	* Set:: Scene - Allows you to set specific scene to any component.
	* ::GOSU:: - Now recognize between URL & SCENES
1.0.2 Beta:: 4/20/2013
	* Set :: Layer - Allows you to set a specific layer to any component.
	* If ::GOSU:: is active and component have layer set to it that layer will be active.
	* If ::GOSU:: is active and you double click component with layer set to it then that layer will be isolated on & off.
	* Tool will be desactivated if 'Escape' key is pressed.
1.0.3:: 4/22/2013
	*Set :: Sound - Allows you to set a specific sound to any component.
	*Set:: Files - Allows you to set a specific file to any component.
	*Set:: Folder - Allows you to set a specific folder to any component.
	*::GOSU Files:: - Default folder for GOSU tools
	*Run,Pause&Close Buttons
	*Dlg set position is disabled.
1.0.4:: 4/23/2013
	*Set :: Name - Allows you to set a specific name to any component.
	*Set :: Empty - Allows you to clear the name of any component.
	*Reset Button - This will remove the 'Set:: Attributes' of every component.
1.0.5:: 4/26/2013
	* Right click sub menu to choose functions.
=end

module RND_GOSU

	class GOSU
	
		@@model = Sketchup.active_model ;
		@@dir = File.dirname(__FILE__) # this plugin's folder
		@@path = File.join(@@dir, '/RND_GOSU/')
		@@rnd_gosu = "rnd_gosu.html" ;
		@@cursors = File.join(@@dir, '/RND_GOSU/Images/Cursor/')
		@@gosu_files = File.join(@@dir, '/RND_GOSU/GOSUFiles/')
		@@gosu_dlg = nil ;
		@@yesCursor = nil ;
		
		def initialize()
	
		@entities = {}
		
		@gosu_1_file =  File.join(@@path, @@rnd_gosu) 
	   
			if (!@gosu_1_file) then 
				UI.messagebox("Cannot find file '#{@@rnd_gosu} in folder '#{@@path}'") ; 
				return ;
			end ; 
			
			if @@gosu_dlg == nil
				@@gosu_dlg = UI::WebDialog.new("RND_GOSU v.1.0.5", false, "RND_GOSU v.1.0.5", 250, 575, 70, 95, true) ;

				@@gosu_dlg.add_action_callback("push_frame") do |d,p| 
				push_frame(d,p) 
				end
			end
			
			@@gosu_dlg.set_size(250, 575) ;
			@@gosu_dlg.set_file(@gosu_1_file) ;
			@@gosu_dlg.show() ; 
			#@@gosu_dlg.set_position (70,95) ;
			
			@@go_su = true ;

		end #def 
		
		
		
		def push_frame(dialog,data)
				
			params = query_to_hash(data) ;  # parse state information 
			
			if params['add_mult'].to_s == "go" 
				@@go_su = true ;
				@@set_name = false ;
				@@set_url = false ;
				@@set_scene = false ;
				@@set_layer = false ;
				@@set_sound = false ;
				@@set_file = false ;
				@@set_folder = false ;
				@@set_empty = false ;
				@@folder_gosu_files = false ;
			end
			if params['add_mult'].to_s == "name" 
				@@go_su = false ;
				@@set_name = true ;
				@@set_url = false ;
				@@set_scene = false ;
				@@set_layer = false ;
				@@set_sound = false ;
				@@set_file = false ;
				@@set_folder = false ;
				@@set_empty = false ;
				@@folder_gosu_files = false ;
			end
			if params['add_mult'].to_s == "set" 
				@@go_su = false ;
				@@set_name = false ;
				@@set_url = true ;
				@@set_scene = false ;
				@@set_layer = false ;
				@@set_sound = false ;
				@@set_file = false ;
				@@set_folder = false ;
				@@set_empty = false ;
				@@folder_gosu_files = false ;
			end
			if params['add_mult'].to_s == "scene" 
				@@go_su = false ;
				@@set_name = false ;
				@@set_url = false ;
				@@set_scene = true ;
				@@set_layer = false ;
				@@set_sound = false ;
				@@set_file = false ;
				@@set_folder = false ;
				@@set_empty = false ;
				@@folder_gosu_files = false ;
			end
			if params['add_mult'].to_s == "layer" 
				@@go_su = false ;
				@@set_name = false ;
				@@set_url = false ;
				@@set_scene = false ;
				@@set_layer = true ;
				@@set_sound = false ;
				@@set_file = false ;
				@@set_folder = false ;
				@@set_empty = false ;
				@@folder_gosu_files = false ;
			end
			if params['add_mult'].to_s == "sound" 
				@@go_su = false ;
				@@set_name = false ;
				@@set_url = false ;
				@@set_scene = false ;
				@@set_layer = false ;
				@@set_sound = true ;
				@@set_file = false ;
				@@set_folder = false ;
				@@set_empty = false ;
				@@folder_gosu_files = false ;
			end
			if params['add_mult'].to_s == "file" 
				@@go_su = false ;
				@@set_name = false ;
				@@set_url = false ;
				@@set_scene = false ;
				@@set_layer = false ;
				@@set_sound = false ;
				@@set_file = true ;
				@@set_folder = false ;
				@@set_empty = false ;
				@@folder_gosu_files = false ;
			end
			if params['add_mult'].to_s == "folder" 
				@@go_su = false ;
				@@set_name = false ;
				@@set_url = false ;
				@@set_scene = false ;
				@@set_layer = false ;
				@@set_sound = false ;
				@@set_file = false ;
				@@set_folder = true ;
				@@set_empty = false ;
				@@folder_gosu_files = false ;
			end
			if params['add_mult'].to_s == "empty" 
				@@go_su = false ;
				@@set_name = false ;
				@@set_url = false ;
				@@set_scene = false ;
				@@set_layer = false ;
				@@set_sound = false ;
				@@set_file = false ;
				@@set_folder = false ;
				@@set_empty = true ;
				@@folder_gosu_files = false ;
			end
			
			if params['add_mult'].to_s == "gosu_files" 
				@@go_su = false ;
				@@set_name = false ;
				@@set_url = false ;
				@@set_scene = false ;
				@@set_layer = false ;
				@@set_sound = false ;
				@@set_file = false ;
				@@set_folder = false ;
				@@set_empty = false ;
				@@folder_gosu_files = true ;
			end
			
			
			#Click Run
			if params['active'].to_s == "1" 
				
				Sketchup.active_model.select_tool RND_GOSU::GOSU.new
				activate = 0
			script = "top.active = " + activate.to_s + ";"
			dialog.execute_script(script);
			end
			
			#Click Pause
			if params['pause'].to_s == "1" 
				
				Sketchup.send_action('selectSelectionTool:') ; #Selection Tool
				paused = 0
			script = "top.pause = " + paused.to_s + ";"
			dialog.execute_script(script);
			end
			
			#Click Done
			if params['done'].to_s == "1" 
				@@close = true
				@@sel_all.clear ; 
				Sketchup.send_action('selectSelectionTool:') ; #Selection Tool
				@@gosu_dlg.close ;
			else
				@@close = false
			end
			
			#Click Reset All
			if params['reset_all'].to_s == "1" 
				
			result = UI.messagebox "Do you want to remove the 'Set:: Attributes' of every component?", MB_YESNOCANCEL
			if result == 6 # Yes
 
				model=Sketchup.active_model
				model.definitions.each{|defn|
				  name=defn.name
				  puts "Defn Name= "+name
				  name.gsub!(/[0-9]+$/,'')
				  name='Doh!' if name==''
				  defn.instances.each{|inst|
					inst.name=""
					puts "Inst Name= "+name
				  }
				}
				end
				resetall = 0
				script = "top.reset_all = " + resetall.to_s + ";"
				dialog.execute_script(script);
			
			end
			
		end #def
		
		
		
		def unescape(string)
			if string != nil
				string = string.gsub(/\+/, ' ').gsub(/((?:%[0-9a-fA-F]{2})+)/n) do
					[$1.delete('%')].pack('H*')
				end
			end
			return string
		end #def
		
		
		
		def query_to_hash(query)
			param_pairs = query.split('&')
			param_hash = {}
			for param in param_pairs
				name, value = param.split('=')
				name = unescape(name)
				value = unescape(value)
				param_hash[name] = value
			end
			return param_hash
		end #def
		
		
		
		def activate
			@@sel_all = Sketchup.active_model.selection ;
			@@sel = Sketchup.active_model.selection[0] ;
			@@sel_first = Sketchup.active_model.selection.respond_to?(:first)
			
			@@ents = Sketchup.active_model.active_entities ;	
					
			# -------------------------------------------------------------------------
			# Change Cursor
			# ------------------------------------------------------------------------- 
			if not @@yesCursor
			
				cursorpath=File.join(@@cursors, "yesCursor.png") 

				if cursorpath
				  @@yesCursor=UI::create_cursor(cursorpath,0,30)
				else
				  UI.beep
				end
			end
			
			
	
			def onSetCursor()
	
				cursor=UI::set_cursor(@@yesCursor)
			
			end #def
			
		end #def
		
		
	
		def onMouseMove(flags,x,y,view)
		
				@@sel = Sketchup.active_model.selection[0] ;
	
				select_comp=view.pick_helper
				select_comp.do_pick x,y
				@selected_comp=select_comp.best_picked 

		
				#Hightlight Selection Feature
				@ents = Sketchup.active_model.active_entities ;
				@ss = Sketchup.active_model.selection
				@ss.clear
			
				
				if @ents.is_a?(Sketchup::ComponentInstance)
				@ss.add(@selected_comp)
				end
			

				@name_def = @selected_comp.definition.name
				@layer_def = @selected_comp.definition.layer
				@name = @selected_comp.name
				
				Sketchup.set_status_text(@@sel.name)
				view.tooltip = @@sel.name
				
				#----------------------------------------------
				#Point
				#----------------------------------------------
				ip1 = view.inputpoint x,y ;
				@point = ip1.position ;
				
		end #def
		
		
		
		def get_sound_file(title = "Choose a sound file")
		  filepath = UI.openpanel( title, "*.wav" )
		  if filepath
			@sound = filepath.gsub("\\",'/')
		  else
			return nil
		  end
		end # method
		
		
		
		def get_file(title = "Choose a file")
		  filepath = UI.openpanel( title, "")
		  if filepath
			@file = filepath.gsub("\\",'/')
		  else
			return nil
		  end
		end # method
		
		
		
		def get_folder(title = "Choose a folder")

		  filepath = UI.openpanel( title, "" )
		
		  if filepath
			file_path = filepath.gsub("\\",'/')
			@folder = File.dirname(file_path) 
		  else
			return nil
		  end
		end # method
		
		

		def onLButtonDown(flags,x,y,view)
		
			model = Sketchup.active_model
			pages = model.pages			
			layers = model.layers
			
			
			#----------------------------	
			#Set:: Name	
			#----------------------------
			if @@set_name == true 
			
				@@sel = Sketchup.active_model.selection[0] ;
			
				results = inputbox(["Enter Name:"], [@@sel.name], "Set:: NAME")

				return if !results
				@@sel.name = results[0]
				
			end
			
			#----------------------------	
			#Set:: URL	
			#----------------------------
			if @@set_url == true 
			
				@@sel = Sketchup.active_model.selection[0] ;
			
				results = inputbox(["Enter URL:"], [@@sel.name], "Set:: URL")

				return if !results
				@@sel.name = results[0]
				
			end	
			
			#----------------------------	
			#Set:: SCENE	
			#----------------------------
			if @@set_scene == true 
				@@sel = Sketchup.active_model.selection[0] ;
				results = inputbox(["Enter Scene Name:"], [@@sel.name], "Set:: SCENE")

				return if !results
				@@sel.name = results[0]
				pages.add results[0]
			end	
			
			#----------------------------	
			#Set:: LAYER	
			#----------------------------
			if @@set_layer == true 
				@@sel = Sketchup.active_model.selection[0] ;
				@@sel.definition.name
				
				results = inputbox(["Enter Layer Name:"], [@@sel.name], "Set:: LAYER")

				return if !results
				@@sel.name = results[0]
				layers.add results[0]
			
		
				layer = Sketchup.active_model.layers.add results[0]
				@@sel.layer = results[0]
			
			end	
			
			#----------------------------	
			#Set:: Sound	
			#----------------------------
			if @@set_sound == true
			
			get_sound_file(title = "Set:: SOUND")

				@@sel.name = @sound		
			end	
			
			#----------------------------	
			#Set:: Files	
			#----------------------------
			if @@set_file == true
			
			get_file(title = "Set:: FILES")

				@@sel.name = @file		
			end	
			
			#----------------------------	
			#Set:: Folder	
			#----------------------------
			if @@set_folder == true 
				get_folder(title = "Set:: FOLDER")
				
				@@sel.name = @folder
			end	
			
			#----------------------------	
			#Set:: Empty	
			#----------------------------
			if @@set_empty == true 
			
				@@sel = Sketchup.active_model.selection[0] ;
		
				@@sel.name = ""
				UI.beep
			end
			
			#----------------------------	
			#Folder:: Gosu Files
			#----------------------------
			if @@folder_gosu_files == true
				UI.openURL(@@gosu_files)
			end	
			
			
			#----------------------------
			#::GOSU::	
			#----------------------------			
			if @@sel.name == "" && @@go_su == true

			UI.messagebox("Please use the 'Set::' options before using ::GOSU::") ;
			
			else
				if @@go_su == true 
				
				
				if @@sel.name[-4..-1] != ".wav" #Don't Run if file is "*.wav"
					UI.openURL("#{@name}")
				end
				
					#----------------------------
					#Play Sound
					#----------------------------
					#@@sel = Sketchup.active_model.selection[0] ;
					
					@sound_wav = @@sel.name
					
					if @@sel.name[-4..-1] == ".wav"
					UI.play_sound @sound_wav
					end
					
					#----------------------------	
					#Go:: Scene	
					#----------------------------
					rm1 = @@sel.name ;
					
					page_num = 0 ;
					
					if @@sel.name 
						pages.each do |e|
						  if e.name == rm1
							pages.selected_page = model.pages[page_num]
							break
						  end
						  page_num+=1
						end
					end	
					
					#----------------------------	
					#Go:: Layer	
					#----------------------------
					model.active_layer = @@sel.name
				
				end	
			end
	
		end #def
		
		
		
		def onLButtonDoubleClick(flags,x,y,view)
		
			model = Sketchup.active_model
			pages = model.pages			
			layers = model.layers
				#----------------------------
				#Isolate Layer On & Off
				#----------------------------
				layer = []
				layers.each do | layer | 
				
						if layer.visible? == true && layer.name != @@sel.name
							layer.visible = false 
						else 
							if layer.visible? == false && layer.name != @@sel.name
								layer.visible = true	
							end
						end		
					
				end
				
		end #def
		
		
		
	end #class
	
end #module

unless file_loaded?( File.basename(__FILE__) )
	$renderiza_menu.add_item('GOSU') { 
	Sketchup.active_model.select_tool RND_GOSU::GOSU.new
	}
	$renderiza_menu.add_separator
	# Add toolbar
	rnd_gosu_tb = UI::Toolbar.new "GOSU"
	rnd_gosu_cmd = UI::Command.new("GOSU") { 
	Sketchup.active_model.select_tool RND_GOSU::GOSU.new 
	} 
	rnd_gosu_cmd.small_icon = "RND_GOSU/img/rnd_gosu_1_16.png"
	rnd_gosu_cmd.large_icon = "RND_GOSU/img/rnd_gosu_1_24.png"
	rnd_gosu_cmd.tooltip = "GOSU - Open URL by clicking on Component"
	rnd_gosu_cmd.menu_text = "GOSU"
	rnd_gosu_tb = rnd_gosu_tb.add_item rnd_gosu_cmd
	rnd_gosu_tb.show
	
	# Add Context Menu
	UI.add_context_menu_handler{|menu|
	
		rclick_menu  = menu.add_submenu("GOSU")
		rclick_menu.add_item('::GOSU::'){
	
			model = Sketchup.active_model
			pages = model.pages			
			@@sel = Sketchup.active_model.selection[0] ;
	
				if @@sel.name[-4..-1] != ".wav" #Don't Run if file is "*.wav"
					UI.openURL("#{@@sel.name}")
				end
				
					#----------------------------
					#Play Sound
					#----------------------------
					@sound_wav = @@sel.name
					
					if @@sel.name[-4..-1] == ".wav"
					UI.play_sound @sound_wav
					end
					
					#----------------------------	
					#Go:: Scene	
					#----------------------------
					rm1 = @@sel.name ;
					
					page_num = 0 ;
					
					if @@sel.name 
						pages.each do |e|
						  if e.name == rm1
							pages.selected_page = model.pages[page_num]
							break
						  end
						  page_num+=1
						end
					end	
					
					#----------------------------	
					#Go:: Layer	
					#----------------------------
					model.active_layer = @@sel.name
		}
		
		rclick_menu.add_separator
		
		rclick_menu.add_item('Set:: Name'){
			@@sel = Sketchup.active_model.selection[0] ;
		
			results = inputbox(["Enter Name:"], [@@sel.name], "Set:: NAME")

			return if !results
			@@sel.name = results[0]
		}
		
		rclick_menu.add_item('Set:: URL'){
			@@sel = Sketchup.active_model.selection[0] ;
			
			results = inputbox(["Enter URL:"], [@@sel.name], "Set:: URL")

			return if !results
			@@sel.name = results[0]
		}
		
		rclick_menu.add_item('Set:: Scene'){
			model = Sketchup.active_model
			pages = model.pages			
			@@sel = Sketchup.active_model.selection[0] ;
			
			results = inputbox(["Enter Scene Name:"], [@@sel.name], "Set:: SCENE")

			return if !results
			@@sel.name = results[0]
			pages.add results[0]
		}
		
		rclick_menu.add_item('Set:: Layer'){
			model = Sketchup.active_model		
			layers = model.layers
		
			@@sel = Sketchup.active_model.selection[0] ;
			@@sel.definition.name
			
			results = inputbox(["Enter Layer Name:"], [@@sel.name], "Set:: LAYER")

			return if !results
			
			@@sel.name = results[0]
			layers.add results[0]
		
			layer = Sketchup.active_model.layers.add results[0]
			@@sel.layer = results[0]
		}
		
		rclick_menu.add_item('Set:: Sound'){
			@@sel = Sketchup.active_model.selection[0] ;
			title = "Choose a sound file"
			filepath = UI.openpanel( title, "*.wav" )
			if filepath
				@sound = filepath.gsub("\\",'/')
			else
				return nil
			end
		
			@@sel.name = @sound			
		}
		
		rclick_menu.add_item('Set:: Files'){
			@@sel = Sketchup.active_model.selection[0] ;
			
			title = "Choose a file"
			filepath = UI.openpanel( title, "")
			if filepath
				@file = filepath.gsub("\\",'/')
			else
				return nil
			end
			
			@@sel.name = @file	
		}
		
		rclick_menu.add_item('Set:: Folder'){
			@@sel = Sketchup.active_model.selection[0] ;

			title = "Choose a folder"
			filepath = UI.openpanel( title, "" )
			if filepath
				file_path = filepath.gsub("\\",'/')
				@folder = File.dirname(file_path) 
			else
				return nil
			end
			
			@@sel.name = @folder
		}
		
		rclick_menu.add_item('Set:: Empty'){
			@@sel = Sketchup.active_model.selection[0] ;
		
			@@sel.name = ""
			UI.beep
		}
		
		rclick_menu.add_separator
		
		rclick_menu.add_item('::Gosu Files::'){
			@@dir = File.dirname(__FILE__) # this plugin's folder
			@@gosu_files = File.join(@@dir, '/RND_GOSU/GOSUFiles/')
			
			UI.openURL(@@gosu_files)
		}
   }

   
end

file_loaded( File.basename(__FILE__) )   # Mark the script loaded. 